
-- ėpAICu

-- 萔錾
EVENT_BEGIN_STATE = 1
EVENT_END_STATE = 2
EVENT_BOTH = 3

-- [V
MOTION_DAMAGE = 4 -- _[W̃[V
MOTION_PICKUP = 5 -- E 
MOTION_SIT = 6
MOTION_SKILL = 7 -- XLUiCxAJ[g{[VAEh{CXj
MOTION_CASTING = 8 -- r
MOTION_PP = 12 -- |[Vsb`[
MOTION_SLIMPP = 28 -- X|[Vsb`[

-- zXL
SKILL_TOUCH_OF_HEAL = 8001
SKILL_EMERGENCY_AVOID = 8002
--SKILL_BRAIN_SURGERY

SKILL_CASTLING = 8005
SKILL_DEFENCE = 8006
--SKILL_ADAMANTIUM_SKIN

SKILL_MOONLIGHT = 8009
SKILL_FLEET_MOVE = 8010
SKILL_OVERED_SPEED = 8011

SKILL_CAPRICE = 8013
SKILL_CHAOTIC_VENEDICTION = 8014
--SKILL_CHANGE_INSTRUCTION

MAXLV_TOUCH_OF_HEAL = 5
MAXLV_EMERGENCY_AVOID = 5

MAXLV_CASTLING = 5
MAXLV_DEFENCE = 5

MAXLV_MOONLIGHT = 5
MAXLV_FLEET_MOVE = 5
MAXLV_OVERED_SPEED = 5

MAXLV_CAPRICE = 5
MAXLV_CHAOTIC_VENEDICTION = 5

if not table then
	
	local internal = {}	-- Ԃ̍Č
	
	table = {}
	
	function table.setn( t, n )
		if t.n then
			t.n = n
		else
			internal[ t ] = n
		end
	end
	
	function table.getn( t )
		if t.n then return t.n end
		if internal[ t ] then return internal[ t ] end
		local n = 0
		for i, v in ipairs( t ) do
			n = i
		end
		return n
	end
	
	function table.insert( t, pos, value )
		local n = table.getn( t )
		if not value then
			value = pos
			pos = n + 1	-- ftHgl
		end
		for i = n, pos, -1 do 	-- ̗vf炷
			t[i+1] = t[i]
		end
		t[ pos ] = value
		table.setn( t, n + 1 )
	end
	
	function table.remove( t, pos )
		local n = table.getn( t )
		if not pos then pos = n end	-- ftHgl
		t[ pos ] = nil
		for i = n - 1, pos, -1 do
			t[i] = t[i+1]
		end
		table.setn( t, n - 1 )
	end
	
	function table.foreach( t, f )
		for k,v in pairs( t ) do
			local r = f( k, v )
			if r ~= nil then
				return r
			end
		end
	end
	
	function table.foreachi( t, f )
		for i = 1, t.n do
			local r = f( i, t[i] )
			if r ~= nil then
				return r
			end
		end
	end
end

-- ֐

function Eval( eval )	-- eval֐ȂsAłȂevalԂ
	if type( eval ) == "function" then
		return eval()
	else
		return eval
	end
end

do
	local theEventTable = {}
	local theEventCount = 0

	function SetEvent( flag, eval, func )
		assert( type( func ) == "function")
		
		theEventCount = theEventCount + 1
		theEventTable[ theEventCount ] = { flag, eval, func }
		return theEventCount
	end
	
	function RemoveEvent( id )
		theEventTable[ id ] = nil
	end
	
	function GetEvent( id )
		return unpack( theEventTable[ id ] )
	end

	function DispatchEvents( flag )
		assert( flag )

		for id, v in ipairs( theEventTable ) do
			if v then
				local f, eval, func = unpack( v )
				if ( f == flag or f == EVENT_BOTH ) and Eval( eval ) then
					func( id, flag )
				end
			end
		end
	end
end

do
	local theEventTable = {}
	local theEventCount = 0
	
	function TranslateSkillCommand( level, skill, ... )
		for i,v in ipairs( theEventTable ) do
			local l, s, func = unpack( v )
			if l == level and s == skill then
				func( unpack( arg ) )	-- id or x, y
				return true
			end
		end
		return false
	end

	function SetSkillConfig( level, skill, func )
		assert( type( func ) == "function")
		
		if type( skill ) == "table" then	-- o^
			local ids = { n = 0 }
			for i,v in ipairs( skill ) do
				ids.n = ids.n + 1
				ids[ ids.n ] = SetSkillConfig( level, v, func )
			end
			return unpack( ids )	-- o^IDԂ
		end
		
		theEventCount = theEventCount + 1
		theEventTable[ theEventCount ] = { level, skill, func }
		return theEventCount
	end
end

function IsNaturalObjectType( num )
	return num >= 1078 and num <= 1085
end

function GetType( id )
	return GetV( V_HOMUNTYPE, id )
end

function IsNaturalObject( id )
	return IsNaturalObjectType( GetV( V_HOMUNTYPE, id ) )
end

do
	local ignores
	
	local function InitIgnores()
		ignores = {}
		local n = 0
		if Settings.USE_MOBDATA and GetMobTable() then
			for i,v in ipairs( Settings.IGNORE_MONSTER_NAME_TABLE ) do
				local id = GetMobIdByName( v )
				if id then
					n = n + 1
					ignores[ n ] = id
					TraceAI("Set Ignore: "..tostring(ignores[ n ]))
				else
					TraceAI("MobData: OԈĂ܂ \""..v.."\"")
				end
			end
		end
		for i,v in ipairs( Settings.IGNORE_MONSTER_ID_TABLE ) do
			n = n + 1
			ignores[ n ] = v
			TraceAI("Set Ignore: "..tostring(ignores[ n ]))
		end
	end
	
	local bioplants = { 1589, 1579, 1575, 1555, 1590 }
	
	function IsIgnoreType( num )
		if Settings.IGNORE_NATURAL_OBJECT and IsNaturalObjectType( num ) then
			return true
		end
		if Settings.IGNORE_BIOPLANT and Contains( bioplants, num ) then	-- oCIvgȂ
			return true
		end
		if Settings.USE_MOBDATA then
			local lv = GetMobInfo( num, M_V_LV )
			if Settings.IGNORE_MONSTER_LEVEL and lv and lv >= Settings.IGNORE_MONSTER_LEVEL then
				return true
			end
		end
		if not ignores then
			InitIgnores()
		end
		if Contains( ignores, num ) then
			return true
		end
		return false
	end
end

function IsIgnore( id )
	return IsIgnoreType( GetV( V_HOMUNTYPE, id ) )
end

function IsNotNoManner( myid, id )
	local target = GetV( V_TARGET, id )
	return target == 0 or ( target == myid or target == GetV( V_OWNER, myid ) or (Settings.FRIEND and IsFriend( target )) )
end

function TraceObject( v )
	local x, y = GetV( V_POSITION, v )
	TraceAI( string.format("id:%d hp:%d type:%d homtype:%d x:%d y:%d motion:%d target:%d a-range:%d owner:%d ismob:%d",
		v,
		GetV( V_HP, v ),
		GetV( V_TYPE, v ),
		GetV( V_HOMUNTYPE, v ),
		x, y,
		GetV( V_MOTION, v ),
		GetV( V_TARGET, v ),
		GetV( V_ATTACKRANGE, v ),
		GetV( V_OWNER, v ),
		IsMonster( v ) ) )
end

function GetPercentHP( id )
	return GetV( V_HP, id ) / GetV( V_MAXHP, id ) * 100
end

function GetPercentSP( id )
	return GetV( V_SP, id ) / GetV( V_MAXSP, id ) * 100
end

do
	local familyTable = {
		{ LIF, LIF2, LIF_H, LIF_H2 },
		{ AMISTR, AMISTR2, AMISTR_H, AMISTR_H2 },
		{ FILIR, FILIR2, FILIR_H, FILIR_H2 },
		{ VANILMIRTH, VANILMIRTH2, VANILMIRTH_H, VANILMIRTH_H2 },
	}
	
	function IsFamily( hom1, hom2 )
		if hom1 == hom2 then
			return true
		end
		for i,v in ipairs( familyTable ) do
			local count = 0
			for i2, v2 in ipairs( v ) do
				if v2 == hom1 or v2 == hom2 then	-- hom1 == hom2 ̃P[X͊֐`return
					count = count + 1
				end
			end
			if count == 2 then
				return true
			end
		end
		return false
	end
end

function SetSkillInterval( family, minsp, delay, lv, skill, target ) -- xXLdelay~bƂɎg
	if not target then
		target = ref("MyID")
	end
	local t = tick_timer( delay )
	t() 	-- ^C}[Jn
	SetEvent( EVENT_BEGIN_STATE,
		function()
			return IsFamily( GetV( V_HOMUNTYPE, MyID ), family ) and GetV( V_SP, MyID ) >= Eval( minsp ) and t()
		end,
		function()
			local id = Eval( target )
			if id > 0 then
				SkillObject( MyID, lv, skill, id )
				TraceAI("Use Skill Interval: lv="..tostring(lv).." skill="..tostring(skill).." to="..tostring(id))
			end
		end )
end

function CalcPercentValue( number, percent )	-- minsp ɓnƂɎgƕ֗H
	return number * percent / 100
end

function Contains( list, value )	-- list  value ܂܂Ă邩
	for i,v in ipairs( list ) do
		if value == v then
			return true
		end
	end
	return false
end

function MoveToNear( myid, id, dis )	-- id  dis }Xꂽꏊ܂ōŒZňړ
	local x, y = GetV( V_POSITION, id )
	local x2, y2 = GetV( V_POSITION, myid )
	local dx, dy = x, y
	if x > x2 then dx = x - dis elseif x < x2 then dx = x + dis end 	-- ƂvZȂłˁc
	if y > y2 then dy = y - dis elseif y < y2 then dy = y + dis end
	Move( myid, dx, dy )
end

function MoveToOwnerEx( myid )	-- 
	local owner = GetV( V_OWNER, myid )
	if GetDistance2( myid, owner ) > 1 then	-- Ă鎞݈̂ړ
		MoveToNear( myid, owner, 1 )
	end
end

function SetVirtualOwner( myid, owner )	-- I[i[Ϗ nilŉ
	if not raw_GetV then
		raw_GetV = GetV
		raw_MoveToOwner = MoveToOwner
	end
	if owner then
		GetV = function( ... )	-- XV
			if arg[1] == V_OWNER and arg[2] == myid then
				return owner
			end
			return raw_GetV( unpack( arg ) )	-- SKILLRANGE ̈͂RȂ̂ŁAɑΉ
		end
		MoveToOwner = function( id )
			local x, y = GetV( V_POSITION, GetV( V_OWNER, id ) )
			Move( id, x, y )
		end
	else
		GetV = raw_GetV
		MoveToOwner = raw_MoveToOwner
	end
end

do
	local cmdtable = { n = 0 }
	
	function ProcessCommandEx( msg, res )
		if not TranslateCommand( msg, res ) then	-- [U[R}htrue(ς)ԂȂ
			ProcessCommand( msg )
		end
	end
	
	function TranslateCommand( msg, res )	-- R}h[U[R}hɖ|
		for id, v in ipairs( cmdtable ) do
			local cmd, r, func = unpack( v )
			if cmd and msg[1] == cmd and res == r then
				if func( id, unpack( msg ) ) then	-- [U[R}hIDAR}h(msg[1])AR}h ̏œn
					return true
				end
			end
		end
		return false
	end

	-- cmd R}h^Cv
	-- res s͂ǂ
	function SetUserCommand( cmd, res, func )
		cmdtable.n = cmdtable.n + 1
		cmdtable[ cmdtable.n ] = { cmd, res, func }
		return cmdtable.n
	end
	
	function RemoveUserCommand( id )
		cmdtable[id] = nil
	end
	
end

do
	local FILENAME = PACKAGE_DIR.."/friendlist.txt"
	local list = {}
	
	function LoadFriendList()
		local exists, iter = pcall( io.lines, FILENAME )	-- t@CȂƃG[o邽
		if exists then
			for line in iter do
				list[ tonumber( line ) ] = {}
			end
		end
	end
	
	function SaveFriendList()
		local f = io.open( FILENAME, "w")
		for k, v in pairs( list ) do
			if v then
				f:write( k.."\n" )
			end
		end
		f:close()
	end
	
	function GetFriends()
		return list
	end
	
	function IsFriend( id )
		return list[ id ]
	end
	
	function RegisterFriend( id )
		list[ id ] = {}
		SaveFriendList()
	end
	
	function UnregisterFriend( id )
		list[ id ] = nil
		SaveFriendList()
	end
end

-- MobData API

function GetMobTable()
	return MOBDATA
end

function GetMobInfo( id, mv )
	local table = GetMobTable()
	if not table then
		return nil
	end
	return table[id] and table[id][mv]
end

do
	local FILE_NAMEREF = PACKAGE_DIR.."/mobnameref.txt"
	
	local nameref = {}	-- LbV
	
	function GetMobIdByName( name )
		if nameref[ name ] then
			return id
		end
		local table = GetMobTable()
		if not table then
			return nil
		end
		for k,v in pairs( table ) do
			if v[ M_V_NAME ] == name then
				nameref[ name ] = k
				return k
			end
		end
		return nil
	end

	function LoadNameRef()
		local f = io.open( FILE_NAMEREF )
		if not f then
			return
		end
		local file
		repeat
			line = f:read()
			if line then
				local index = string.find( line, "\t")
				if index then
					local name = string.sub( line, 1, index - 1 )
					local id = tonumber( string.sub( line, index + 1 ) )
					nameref[ name ] = id
					TraceAI("Load NameRef: "..name.." "..tostring( id ) )
				end
			end
		until not line
		f:close()
	end

	function SaveNameRef()
		local f = io.open( FILE_NAMEREF, "w")
		for k,v in pairs( nameref ) do
			f:write( k.."\t"..v.."\n" )
		end
		f:close()
	end
end

function IsPlayer(id)
	if (IsMonster(id) == 1) then
		return false
	elseif (id < 65536 or id == -1) then
		return false
	end

	local idtype = GetV(7,id)

	if (0 <= idtype and idtype <= 23) then
		return true
	elseif (4001 <= idtype and idtype <= 4044) then
		return true
	elseif (4046 <= idtype and idtype <= 4050) then
		return true
	else
		return false
	end
end

function IsHomunclus( id )
	local type = GetV( V_HOMUNTYPE, id )
	return id > 0 and id <= 65535 and type >= 1 and type <= 16 and IsMonster(id) == 0
end

function IsPet( id )	-- b
	local type = GetType( id )
	return IsMonster( id ) == 0 and type >= 1001 and type <= 1625
end


function IsInSearchSight( myid, enemy )
	return not Settings.SEARCH_DISTANCE or GetDistance2( GetV( V_OWNER, myid ), enemy ) <= Settings.SEARCH_DISTANCE
end

function IsAlive( id )
	local motion = GetV( V_MOTION, id )
	return motion ~= -1 and motion ~= MOTION_DEAD
end

function GetNearestPlayer( id ) 	-- id Ƃ߂vC[zT
	local list = {}
	for i,v in ipairs( GetActors() ) do
		if v ~= id then
			if ( IsPlayer( v ) or IsHomunclus( v ) ) and ( not Settings.FRIEND or not IsFriend( v ) ) then
				table.insert( list, v )
			end
		end
	end

	return GetNearestActor( id, list )
end

do
	local actives
	
	local function InitActivates()
		actives = {}
		if Settings.USE_MOBDATA and GetMobTable() then
			for i,v in ipairs( Settings.ACTIVATE_MONSTER_NAME_TABLE ) do
				local id = GetMobIdByName( v )
				if id then
					table.insert( actives, id )
					TraceAI("Set Active: "..tostring(id))
				else
					TraceAI("MobData: OԈĂ܂ \""..v.."\"")
				end
			end
		end
		for i,v in ipairs( Settings.ACTIVATE_MONSTER_ID_TABLE ) do
			table.insert( actives, v )
			TraceAI("Set Active: "..tostring(v))
		end
	end
	
	function IsActivateType( num )
		if not actives then
			InitActivates()
		end
		if Contains( actives, num ) then
			return true
		end
		return false
	end
	
	function activate_mob( myid, v )
		if v == 0 then
			return not Settings.AI_ACTIVE	-- ANeBȕꍇ͏s
		end
		
		return IsActivateType( GetType( v ) ) and target_none( myid, v )
	end
end

-- GetEnemy ɓnt@N^
-- v [̂Ƃ͏

function target_myself( myid, v )	-- GetMyEnemyB(U^) ̂
	if v == 0 then
		return true
	end

	if GetV( V_TARGET, v ) == myid and IsAlive( v ) then
		if IsInSearchSight( myid, v ) then
			return true
		end
	end
	return false
end

function target_friend( myid, v )	-- th^QĂG
	if v == 0 then
		return Settings.FRIEND	-- FB@\OFFȂ珉s
	end
	
	if IsFriend( GetV( V_TARGET, v ) ) and IsAlive( v ) then
		if IsInSearchSight( myid, v ) then
			return true
		end
	end
	return false
end

function target_owner( myid, v )	-- P~^QĂG
	if v == 0 then
		return true
	end
	
	if GetV( V_TARGET, v ) == GetV( V_OWNER, myid ) then
		if IsMonster(v) == 1 and IsAlive( v ) then
			return true
		else
			local motion = GetV( V_MOTION, v )
			if motion == MOTION_ATTACK or motion == MOTION_ATTACK2 then
				return true
			end
		end
	end
	return false
end

function target_none( myid, v )	-- GetMyEnemyA(U^) ̂
	if v == 0 then
		return Settings.AI_ACTIVE	-- ANeBuȂ珉s
	end
	
	if not IsIgnore( v ) then
		if 1 == IsMonster(v) and IsNotNoManner( myid, v ) and IsAlive( v ) then
			if IsInSearchSight( myid, v ) then
				if Settings.PLAYER_DISTANCE then
					local pc = GetNearestPlayer( v )
					TraceAI("Nearest: "..tostring(pc))
					if pc == 0 or GetDistance2( pc, v ) > Settings.PLAYER_DISTANCE then
						return true
					end
				else
					return true
				end
			end
		end
	end
	return false
end

function SearchEnemy( myid, priority, ignore )	-- G擾
	local ownerTarget = GetV( V_TARGET, GetV( V_OWNER, myid ) )
	
	if Settings.FOLLOW_OWNER_TARGETTING and ownerTarget > 0 and IsAlive( ownerTarget ) then
		return ownerTarget	-- P~̃^QĂG܂݂鎞AŗDɂ
	end
	
	if not priority then	-- Dxw肳ĂȂȂAݒ肵Dxg
		priority = Settings.ENEMY_PRIORITY
	end
	if not ignore then	-- Oݒ
		ignore = {}
	end
	for i,v in ipairs( priority ) do
		if not Contains( ignore, v ) and v( myid, 0 ) then	-- R[ ̂ݗ
			local enemy = GetEnemy( myid, v )
			if enemy ~= 0 then
				return enemy
			end
		end
	end
	return 0
end

function GetNearestActor( id, actors )	-- id Ɉԋ߂IuWFNgԂ
	local result = 0
	local min_dis = 100
	local dis
	for i,v in ipairs( actors ) do
		dis = GetDistance2( id, v )
		if dis < min_dis and dis ~= -1 then
			result = v
			min_dis = dis
		end
	end
	return result
end

function GetEnemy( myid, functor )	-- GetOwnerEnemy, GetMyEnemyA/B Rsyۂ̂œ functor = ]֐
	local enemys = {}
	local index = 1
	for i,v in ipairs( GetActors() ) do
		if v ~= GetV( myid, V_OWNER ) and v ~= myid then
			if functor( myid, v ) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	return GetNearestActor( myid, enemys )
end


Helper = {}	-- O

-- N[W̕]ɓn߂̃A_v^`

function Helper.Not( eval )
	return function()
		return not Eval( eval )
	end
end

function Helper.And( ... )
	return function()
		for i,v in ipairs( arg ) do
			if not Eval( v ) then
				return false
			end
		end
		return true
	end
end

function Helper.Or( ... )
	return function()
		for i,v in ipairs( arg ) do
			if Eval( v ) then
				return true
			end
		end
		return false
	end
end

function Helper.Equals( a, b )
	return function()
		return Eval( a ) == Eval( b )
	end
end

function Helper.NotEquals( a, b )
	return function()
		return Eval( a ) ~= Eval( b )
	end
end

function Helper.Greater( a, b )
	return function()
		return Eval( a ) > Eval( b )
	end
end

function Helper.GreaterEquals( a, b )
	return function()
		return Eval( a ) >= Eval( b )
	end
end

function Helper.Less( a, b )
	return function()
		return Eval( a ) < Eval( b )
	end
end

function Helper.LessEquals( a, b )
	return function()
		return Eval( a ) <= Eval( b )
	end
end

-- N[W쐬ĕԂwp[

function Helper.Bind( func, ... )
	return function()
		-- e[uRs[ȂƓxڈȍ~ɐ]ȂA
		-- clone()gpƃc[\n܂deepcopyĂ܂߁A󂢃Rs[s
		local t = {}
		for i,v in ipairs( arg ) do
			t[i] = Eval( v )
		end
		return func( unpack( t ) )
	end
end

function Helper.If( eval, func, ... )	-- eval^ȂfuncsĕԂAfuncȂΐ^UlԂ
	return function()
		if Eval( eval ) then
			if func then
				return func( arg )
			else
				return true
			end
		end
		return false
	end
end


_if = Helper.If
_not = Helper.Not
_and = Helper.And
_or = Helper.Or
eq = Helper.Equals
ne = Helper.NotEquals
lt = Helper.Less
gt = Helper.Greater
le = Helper.LessEquals
ge = Helper.GreaterEquals
bind = Helper.Bind

function once()	-- xs
	local flag = false
	return function()
		local r = not flag
		flag = true
		return r
	end
end

function timer( interval )	-- intervalbo߂邲ƂtrueԂ
	local t = 0
	return function()
		local t2 = os.time()
		local r = os.difftime( t2, t ) >= interval
		if r then t = t2 end
		return r
	end
end

function tick_timer( interval )	-- interval~bo߂邲ƂtrueԂ
	local t = 0
	return function()
		local t2 = GetTick()
		local r = t2 - t >= interval
		if r then t = t2 end
		return r
	end
end

function ref( name )	-- name ̕ϐQƂ  _G ̕ϐQƂłȂ̂肩c
	return function( ... )
		if type( _G[ name ] ) == "function" then	-- bind ȂǂɊ֐n
			return _G[ name ]( unpack( arg ) )
		else
			return _G[ name ]
		end
	end
end

do
	local function func( v, percent )
		if not percent then percent = 100 end
		return function()
			return CalcPercentValue( GetV( v, MyID ), percent )
		end
	end
	
	function msp( percent )	-- MSPpercent̒lԂ
		return func( V_MAXSP, percent )
	end

	function mhp( percent )	-- MHPpercent̒lԂ
		return func( V_MAXHP, percent )
	end
	
	function sp( percent )	-- SPpercent̒lԂ
		return func( V_SP, percent )
	end

	function hp( percent )	-- HPpercent̒lԂ
		return func( V_HP, percent )
	end
end

function random( min, max )
	return function()
		return math.random( min, max )
	end
end

